<?php
// DB.class.php
require_once('../vendor/autoload.php');

class DB {
    public $_connection;
    private static $_instance;
	
	public static function getInstance() {
		if(!self::$_instance) { // If no instance then make one
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function __construct() {
        $dotenv = new Dotenv\Dotenv(__DIR__);
        $dotenv->load();

		$this->_connection = new mysqli( $_ENV['DB_HOST'], $_ENV['DB_USER'], $_ENV['DB_PASS'], $_ENV['DB_NAME'] );
		if ( mysqli_connect_errno() ) {
			printf("Connection failed: %s\ ", mysqli_connect_error());
			exit();
        }
	}

	private function __clone() { }
	
	public function getConnection() {
		return $this->_connection;
	}
}

?>
