<?php
/**
 * @file
 * Take the user when they return from Twitter. Get access tokens.
 * Verify credentials and redirect to based on response from Tumblr.
 */

/* Start session and load lib */
session_start();
require_once('tumblroauth.php');
require_once('config.php');
require_once('DB.php');

if (!isset($_SESSION) || !isset($_SESSION["userId"]) || !isset($_SESSION["username"])) {
    header("Location: ../index.php");
}

/* If the oauth_token is old redirect to the connect page. */
if (!isset($_SESSION['oauth_token']) || !isset($_SESSION['oauth_token_secret'])
   || (isset($_REQUEST['oauth_token']) && $_SESSION['oauth_token'] !== $_REQUEST['oauth_token'])) {
  $_SESSION['oauth_status'] = 'oldtoken';
  header('Location: ./redirect.php');
}

/* Create TwitteroAuth object with app key/secret and token key/secret from default phase */
$connection = new TumblrOAuth(CONSUMER_KEY, CONSUMER_SECRET, $_SESSION['oauth_token'], $_SESSION['oauth_token_secret']);

/* Request access tokens from twitter */
$access_token = $connection->getAccessToken($_REQUEST['oauth_verifier']);

// /* Save the access tokens. Normally these would be saved in a database for future use. */
// $_SESSION['access_token'] = $access_token;

/* Remove no longer needed request tokens */
unset($_SESSION['oauth_token']);
unset($_SESSION['oauth_token_secret']);

/* If HTTP response is 200 continue otherwise send to connect page to retry */
if (200 == $connection->http_code) {
  /* The user has been verified and the access tokens can be saved for future use */
  $_SESSION['status'] = 'verified';
  $info = $connection->get('user/info');
  if (isset($info['meta'])) {
      if ($info['meta']['msg'] == 'OK') {
            $username = $info['response']['user']['name'];
            $db     = DB::getInstance();
            $mysqli = $db->getConnection();
            $result = $mysqli->query("SELECT *  FROM dashboard WHERE username='".$username."'");
            if (mysqli_num_rows($result) <= 0) {
                $fetchinterval 	= 100;
                $postinterval  	= 100;
                $notecount		= 100;
                $exclude		= "N";
                $posttype		= "";
                $limit			= 50;
                $stmt = $mysqli->prepare("INSERT INTO dashboard (oauth_token, oauth_token_secret, username, qlimit, fetchinterval, postinterval, notecount, posttype, postto, exclude) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                $stmt->bind_param('sssddddsss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $username, $limit, $fetchinterval, $postinterval, $notecount, $posttype, $username, $exclude);
                $stmt->execute();
                $stmt->close();
            } else {
                $at 	= $access_token['oauth_token'];
                $ats 	= $access_token['oauth_token_secret'];
                $result = $mysqli->query("UPDATE `dashboard` SET oauth_token = '$at', oauth_token_secret = '$ats' WHERE username = '$username'");
            }

            $followers  = $info['response']['user']['blogs'][0]['followers'];
            $followings = $info['response']['user']['following'];
            $likes      = $info['response']['user']['likes'];
            $userblog   = $info['response']['user']['name'];
            $blognames  = '';
            $postState  = 'published';

            foreach($info['response']['user']['blogs'] as $index) {
              $blognames .= $index['name'] . ',';
            }

            $mysqli->query("UPDATE `user_info` SET oauth_token = '".$access_token['oauth_token']."', oauth_token_secret = '".$access_token['oauth_token_secret']."', blognames = '$blognames', followers = '$followers',
              followings = '$followings', likes = '$likes', userblog = '$userblog', postState = '$postState' WHERE id='".$_SESSION['userId']."' AND username='".$_SESSION['username']."'");
            
            $db_name = $_SESSION["username"] . "_posts";
            $mysqli->query('DROP TABLE IF EXISTS '.$db_name);
            $mysqli->query("CREATE TABLE IF NOT EXISTS $db_name (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, oauth_token VARCHAR(100), oauth_token_secret VARCHAR(100), 
                        blogname VARCHAR(100), postid VARCHAR(50), reblog_key VARCHAR(50), type VARCHAR(10), notecount INT, state VARCHAR(15), title VARCHAR(100),
                        body longtext, caption TEXT, external_url TEXT, embed longtext, quote TEXT, source TEXT, url TEXT, thumbnail TEXT, description TEXT, author TEXT, excerpt TEXT, 
                        conversation longtext, link TEXT ) ENGINE=InnoDB");

            foreach ($info['response']['user']['blogs'] as $blog) {
                $size = 0;
                $link = 'http://api.tumblr.com/v2/blog/' . $blog['name'] . '.tumblr.com/posts?offset=' . $size . '&notes_info=true&reblog_info=true&api_key=' . CONSUMER_KEY;

                $ch = curl_init($link);
                curl_setopt($ch, CURLOPT_HEADER, 0);
                curl_setopt($ch, CURLOPT_POST, 0);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                $collection = json_decode(curl_exec($ch), true);
                curl_close($ch);

                if (isset($collection["meta"]) && ($collection["meta"]["msg"]=="OK")) {
                    foreach ($collection['response']['posts'] as $post) {
                        $notecount = isset($post['note_count']) ? intval($post['note_count']) : 0;
                        $blogType = $post['type'];
                  
                        switch ($blogType) {
                          case 'text':
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, title, body) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['body']);
                            break;
                  
                          case 'audio':
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, caption, external_url) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['caption'], $post['audio_source_url']);
                            break;
                  
                          case 'video':
                            $caption = "nothing";
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, caption, embed) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $caption, $post['player']['0']['embed_code']);
                            break;
                  
                          case 'quote':
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, quote, source) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['text'], $post['source']);
                            break;
                  
                          case 'link':
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, title, url, description, thumbnail, author, excerpt) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdssssss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['url'], $post['description'], $post['photos']['0']['original_size']['url'], $post['author'], $post['excerpt']);
                            break;
                  
                          case 'chat':
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, title, conversation) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['title'], $post['body']);
                            break;
                  
                          case 'photo':
                            $stmt      = $mysqli->prepare("INSERT INTO $db_name (oauth_token, oauth_token_secret, blogname, postid, reblog_key, type, notecount, caption, source, link) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                            $stmt->bind_param('ssssssdsss', $access_token['oauth_token'], $access_token['oauth_token_secret'], $blog['name'], $post['id'], $post['reblog_key'], $blogType, $notecount, $post['caption'], $post['photos']['0']['original_size']['url'], $post['image_permalink']);
                            break;
                  
                          case 'answer':
                            break;
                  
                          default:
                            break;
                        }
                        if ($blogType != 'answer') {
                          $stmt->execute();
                          $stmt->close();
                        }
                    }
                }
            }

            // $_SESSION['tumblrInfo'] = $info;            
            header('Location: ../views/home.php');
      } else {
            echo "<h2>Failed! Please try again! click <a href='../inc/redirect.php'>here!</a></h2>";
             var_dump($info); exit;
      }
  }

} else {
    echo "error"; exit;
  /* Save HTTP status for error dialog on connnect page.*/
  header('Location: ./redirect.php');
}
