const emailRegex = /^[_A-Za-z0-9-]+(\.[_A-Za-z0-9-]+)*(\+[A-Za-z0-9-]+)?@[A-Za-z0-9-]+(\.[A-Za-z0-9-]{2,})*$/;
const nameRegex = /^(?=[a-zA-Z-\s]{2,}$)^[a-zA-Z\s]+(-[a-zA-Z\s]+)*$/;
const pwdRegex = /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{8,}$/;
const headers = {
    blogname: "BlogName",
    fromBlogs: "FromBlogs",
    limit: "Limit",
    notecount: "NoteCount",
    qinterval: "QueueInterval",
    queuename: "QueueName",
    repeat: "Repeat",
    since: "Since",
    tag: "Tag",
    type: "Type",
    until: "Until"
};
let blogcounter = 1;
const bloglimit = 20;

jQuery(document).ready(function() {
    $('#since').datetimepicker();
    $('#until').datetimepicker();
    /** Login  */
    $('#login').submit(function(e) { 
        let identifier = login.elements["identifier"].value;
        let password = login.elements["password"].value;
        let url = 'inc/login.php';

        if (!identifier || !identifier.trim()) {
            $('#identifier').removeClass("error");
            $('#identifier').css({"float" : "left", "margin-left": "5px"});
            login.elements["identifier"].focus();
    
            return false;
        }
        
        if (!password || !pwdRegex.test(password)) {
            $('#password').removeClass("error");
            $('#password').css({"float" : "left", "margin-left": "5px"});
            login.elements["password"].focus();
    
            return false;
        }

        $.ajax({
            type: "POST",
            url: url,
            data: {
                identifier: identifier,
                password: password
            },
            success: function(data)
            {
                if (data === "success") {
                    window.location = 'views/home.php';
                } else {
                    alert("Login Failed");
                    window.location.reload(true);
                }
            }
        });
        e.preventDefault();
    });

    /** Sign up  */
    $('#register').submit(function(e) {
        let username  = $('#register').find('input[name="username"]').val();
        let email     = $('#register').find('input[name="email"]').val();
        let password  = $('#register').find('input[name="password"]').val();
        let rpassword = $('#register').find('input[name="rpassword"]').val();
        let url = 'inc/signup.php';

        if (!username || !username.trim() || !nameRegex.test(username)) {
            $('#rusername').removeClass("error");
            $('#rusername').css({"float" : "left", "margin-left": "5px"});
            
            return false;
        }
    
        if (!email || !emailRegex.test(email)) {
            $('#remail').removeClass("error");
            $('#remail').css({"float" : "left", "margin-left": "5px"});
    
            return false;
        }
    
        if (!password || !pwdRegex.test(password)) {
            $('#rpassword').removeClass("error");
            $('#rpassword').css({"float" : "left", "margin-left": "5px"});
    
            return false;
        }
    
        if (!password || password !== rpassword) {
            $('#cpassword').removeClass("error");
            $('#cpassword').css({"float" : "left", "margin-left": "5px"});
    
            return false;
        }

        $.ajax({
            type: "POST",
            url: url,
            data: {
                username: username,
                email: email,
                password: password
            },
            success: function(data)
            {
                if (data === "success") {
                    alert("Registered successfully");
                    window.location = 'index.php';
                } else {
                    alert("You are already member. Please sign in...");
                    window.location = 'index.php';
                }
            },
            error: function(data)
            {
                alert("Failed...Please try again");
                window.location.reload(true);
            }
        });
        e.preventDefault();
    });

    /** Multiple Posts  */
    $('#multi_blogs').submit(function(e) {
        let queuename = $('input[name=queuename]').val();
        let qinterval = $('input[name=qinterval]').val();
        let blogname  = $('select[name=blog]').val();
        let date      = $('input[name=since]').val();
        let limit     = $('input[name=limit]').val();

        if (!queuename || !qinterval || !blogname || !date || !limit) {
            alert("You have to input the * fields");
            return false;
        }

        date = date.split("/");
        date[2] = date[2].split(" ")[0];
        let f = new Date(date[2], date[0] - 1, date[1]);
        let seconds = f.getTime() / 1000;

        let formData = {
          'queuename': queuename,
          'qinterval': qinterval,
          'blogname': blogname,
          'since': seconds,
          'limit' : limit
        }

        if ($('input[name=input_blog]').val() !== "") {
            formData['fromBlogs'] = $('input[name=input_blog]').val();
        }

        if ($('input[name=tag]').val() !== "") {
            formData['tag'] = $('input[name=tag]').val();
        }

        if ($('select[name=type]').val() !== "") {
            formData['type'] = $('input[name=type]').val();
        }

        if ($('input[name=notecount]').val() === "") {
            formData['notecount'] = 1;
        } else { 
            formData['notecount'] = $('input[name=notecount]').val(); 
        }

        if ($('input[name=repeat]').val() === "") {
            formData['repeat'] = 1;
        } else { 
            formData['repeat'] = $('input[name=repeat]').val(); 
        }

        if ($('input[name=input_tag]').val() !== "") {
            formData['addingTag'] = $('input[name=input_tag]').val();
        }

        if ($('input[name=until]').val() !== "") {
            let dateuntil = $('input[name=until]').val().split("/");
            dateuntil[2] = dateuntil[2].split(" ")[0];
            let ff = new Date(dateuntil[2], dateuntil[0] - 1, dateuntil[1]);
            let secondsuntil = ff.getTime() / 1000;
            formData['until'] = secondsuntil;
        }
        // process the form
        $.ajax({
            type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
            url: '../scripts/action.php', // the url where we want to POST
            data: formData, // our data object
            dataType: 'json', // what type of data do we expect back from the server
            encode: true,
            success: function(data) {
                $('#multiple_posts').prop('disabled', false);
                if (data.success === true) {
                    alert(data.message);
                    window.location = 'runningqueue.php';
                } else {
                    alert(data.errors);
                    return false;
                }
            }
        });
        // stop the form from submitting the normal way and refreshing the page
        e.preventDefault();
        $('#multiple_posts').prop('disabled', true);
    });

    /** Single Post  */
    $('#single_blog').submit(function(e) {
        let queuename = $('input[name=queuename]').val();
        let qinterval = $('input[name=qinterval]').val();
        let blogname  = $('select[name=blog]').val();
        let posts = [];
        for (let i = 0; i < blogcounter; i++) {
        if ($('input[name=input_blog' + i + ']').val() !== "")
            posts.push($('input[name=input_blog' + i + ']').val());
        }
        
        if (!queuename || !qinterval || !blogname || posts.length == 0) {
            alert("You have to input the * fields");
            return false;
        }

        let formData = {
            'queuename': queuename,
            'qinterval': qinterval,
            'blogname': blogname,
            'fromBlogs' : posts
        }

        if ($('input[name=repeat]').val() === "") {
            formData['repeat'] = 1;
        } else { 
            formData['repeat'] = $('input[name=repeat]').val(); 
        }
        
        $.ajax({
            type: 'POST',
            url: '../scripts/singleaction.php',
            data: formData,
            dataType: 'json',
            encode: true,
            success: function(data) {
                $('#single_post').prop('disabled', false);
                if (data.success === true) {
                    alert(data.message);
                    window.location = 'runningqueue.php';
                } else {
                    alert(data.errors);
                    return false;
                }
            }
        });

        e.preventDefault();
        $('#single_post').prop('disabled', true);
    });

    /** Delete Posts Script */
    $('#delete_blog').submit(function(e) {
        let blogname = $('input[name=blog_to_delete]').val();
        let interval = $('input[name=interval]').val();
        let sourceblog  = $('select[name=blog]').val();
        let tag  = $('input[name=delete_tag]').val();

        if (!sourceblog || !interval) {
            alert("Fill the required * fields please.");
            return false;
        }
        
        if (!blogname && !tag) {
            alert("You must input at least one of blog name and tag");
            return false;
        }

        let formData = {
            'sourceblog': sourceblog,
            'interval': interval,
            'blogname' : blogname ? blogname : '',
            'tag': tag ? tag : '' 
        }

        if (confirm('Are you sure you want to track this blog?')) {
            $.ajax({
                type: 'POST',
                url: '../scripts/deletePosts.php',
                data: formData,
                dataType: 'json', 
                encode: true,
                success: function(data) {
                    $('#spt_btn').prop('disabled', false);
                    if (data.success === true) {
                        alert(data.message);
                        window.location = 'activetracker.php';
                    } else {
                        alert(data.errors);
                        return false;
                    }
                }
            });

            $('#spt_btn').prop('disabled', true);
        }

        e.preventDefault();
    })

    /** Track Blog  */
    $('#track_blog').submit(function(e) {
        let sourceblog = $('input[name=blog_to_track]').val();
        let postinterval = $('input[name=post_interval]').val();
        let blogname  = $('select[name=blog]').val();
        
        if(!sourceblog || !postinterval || !blogname) {
            alert("Fill the required * fields please. ");
            return false;
        }

        let formData = {
        'sourceblog': sourceblog,
        'postinterval': postinterval,
        'destblogs' : blogname
        };

        if (typeof tblog !== 'undefined' && tblog.length > 0)
            formData['destblogs'] = tblog;
        
        if ($('input[name=fetch_interval]').val() === "")
            formData['fetchinterval'] = 900;
        else
            formData['fetchinterval'] = $('input[name=fetch_interval]').val();
        
        if ($('input[name=track_tag]').val() !== "")
            formData['tag'] = $('input[name=track_tag]').val();
        
        if ($('input[name=track_type]').val() !== "")
            formData['type'] = $('input[name=track_type]').val();

        if ($('input[name=input_tag]').val() !== "") {
            formData['addingTag'] = $('input[name=input_tag]').val();
        }

        if ($('input[name=track_notecount]').val() !== "") 
            formData['notecount'] = $('input[name=track_notecount]').val();
        
        if (confirm('Are you sure you want to track this blog?')) {
            $.ajax({
                type: 'POST',
                url: '../scripts/trackblog.php',
                data: formData,
                dataType: 'json', 
                encode: true,
                success: function(data) {
                    $('#track_blg').prop('disabled', false);
                    if (data.success === true) {
                        alert(data.message);
                        window.location = 'activetracker.php';
                    } else {
                        alert(data.errors);
                        return false;
                    }
                }
            });

            $('#track_blg').prop('disabled', true);
        }
        e.preventDefault();
    });

    $('#datatable').on('click', 'span#r_see', function() {
        let qname = $(this).parents('tr').find('td:first');
        $.ajax({
            type: 'post',
            url: '../scripts/manageposts.php',
            data: {
                display: true,
                queuename: qname.html()
            },
            success: function(response) {
                $('#datatable').html(response);
            }
        });
    });

    $('#datatable').on('click', 'span#r_update', function() {
        if (confirm('Are you sure you want to update this post?')) {
            let qname = $(this).parents('tr').find('td:first');
            let postInterval = $(this).parents('tr').find('td:nth-child(6)');

            $.ajax({
                type: 'post',
                url: '../scripts/manageposts.php',
                data: {
                    update : true,
                    queuename: qname.html(),
                    interval: postInterval.html()
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#datatable').on('click', 'span#r_delete', function() {
        if (confirm('Are you sure you want to remove this queue?')) {
            let qname = $(this).parents('tr').find('td:first');
            $.ajax({
                type: 'post',
                url: '../scripts/manageposts.php',
                data: {
                    delete : true,
                    queuename: qname.html(),
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#datatable').on('click', 'span#p_delete', function() {
        if (confirm('Are you sure you want to remove this post?')) {
            let id    = $(this).parents('tr').find('td:nth-child(1)');
            let qname = $(this).parents('tr').find('td:nth-child(2)');
            let bname = $(this).parents('tr').find('td:nth-child(3)');

            $.ajax({
                type: 'post',
                url: '../scripts/manageposts.php',
                data: {
                    post_delete : true,
                    id: id.html(),
                    queuename: qname.html(),
                    blogname: bname.html()
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#datatable').on('click', 'span#delete_post', function() {
        if (confirm('Are you sure you want to remove this post?')) {
            let id    = $(this).parents('tr').find('td:nth-child(1)');
            let bname = $(this).parents('tr').find('td:nth-child(2)');
            let pstId = $(this).parents('tr').find('td:nth-child(6)');
            let uname = $('#owner');
            $.ajax({
                type: 'post',
                url: '../scripts/manageposts.php',
                data: {
                    own_post_del : true,
                    id: id.html(),
                    blogname: bname.html(),
                    postId: pstId.html(),
                    username: uname.html()
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#datatable').on('click', 'span#d_update', function() {
        if (confirm('Are you sure you want to update this post?')) {
            let $uname          = $(this).parents('tr').find('td:nth-child(1)');
            let $to             = $(this).parents('tr').find('td:nth-child(2)');
            let $limit          = $(this).parents('tr').find('td:nth-child(3)');
            let $post_interval  = $(this).parents('tr').find('td:nth-child(4)');
            let $notecount      = $(this).parents('tr').find('td:nth-child(5)');
            let $post_type      = $(this).parents('tr').find('td:nth-child(6)');
            let $exclude        = $(this).parents('tr').find('td:nth-child(7)');

            $.ajax({
                type: 'post',
                url: '../scripts/dashboard.php',
                data: {
                    dashboard_update: true,
                    uname : $uname.html(),
                    to: $to.html(),
                    limit:$limit.html(),
                    post_interval: $post_interval.html(),
                    notecount : $notecount.html(),
                    post_type: $post_type.html(),
                    exclude:$exclude.html()
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#d-start').click('on', function() {
        if (confirm('Are you sure you want to start the dashboard queue?')) {
            $('#d-start').css({'pointer-events': 'none', 'cursor': 'not-allowed'});
            $('#d-stop').removeAttr('style');
            $.ajax({
                type: 'post',
                url: '../scripts/dashboard.php',
                data: {
                    start: true
                },
                success: function(response) {
                    alert(response);
                }
            });
        }
    });

    $("#d-stop").on("click", function() {
        if (confirm('Are you sure you want to stop the dashboard queue?')) {
            $('#d-stop').css({'pointer-events': 'none', 'cursor': 'not-allowed'});
            $('#d-start').removeAttr("style");
            
            $.ajax({
                type: 'post',
                url: '../scripts/dashboard.php',
                data: {
                stop: true
                },
                success: function(response) {
                    alert(response);
                }
            });
        }
    });

    $('#datatable').on('click', 'span#a_update', function() {
        if (confirm('Are you sure you want to update this tracker?')) {
            let $id         = $(this).parents('tr').find('td:first');
            let $source     = $(this).parents('tr').find('td:nth-child(2)');
            let $f_nterval  = $(this).parents('tr').find('td:nth-child(4)');
            let $p_nterval  = $(this).parents('tr').find('td:nth-child(5)');
            let $tag        = $(this).parents('tr').find('td:nth-child(6)');
            let $type       = $(this).parents('tr').find('td:nth-child(7)');
            let $notecount  = $(this).parents('tr').find('td:nth-child(8)');

            $.ajax({
                type: 'post',
                url: '../scripts/managetrackers.php',
                data: {
                    update: true,
                    id: $id.html(),
                    sc: $source.html(),
                    fi: $f_nterval.html(),
                    pi: $p_nterval.html(),
                    tg: $tag.html(),
                    tp: $type.html(),
                    nt: $notecount.html(),
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#datatable').on('click', 'span#a_delete', function() {
        if (confirm('Are you sure you want to remove this tracker?')) {
            let $id         = $(this).parents('tr').find('td:first');
            let $source     = $(this).parents('tr').find('td:nth-child(2)');
            let $f_nterval  = $(this).parents('tr').find('td:nth-child(4)');
            let $p_nterval  = $(this).parents('tr').find('td:nth-child(5)');

            $(this).parents('tr').detach();
            $.ajax({
                type: 'post',
                url: '../scripts/managetrackers.php',
                data: {
                    remove: true,
                    id: $id.html(),
                    sc: $source.html(),
                    fi: $f_nterval.html(),
                    pi: $p_nterval.html()
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    //import csv file
    $('#csv_import').click(function() {
        let queuename = $('input[name=queuename]').val();
        let qinterval = $('input[name=qinterval]').val();
        let blogname  = $('select[name=blog]').val();
        
        if (!queuename || !qinterval || !blogname) {
            alert("You have to input the * fields");
            return false;
        }

        let upload_files = $('input[type=file]')[0].files;
        let data = new FormData();

        $.each(upload_files, function(key, value){
            console.log(key + " : " + value);
            data.append(key,value);
        });

        data.append('queuename', queuename);
        data.append('qinterval', qinterval);
        data.append('blogname', blogname);

        $.ajax({
            url: '../scripts/csvimport.php',
            type: 'post',
            data: data,
            cache: false,
            dataType: 'json',
            processData: false,
            contentType: false
        })
        .done(function(data) {
            
            if (data.success) {
                alert('Successfully Imported!');
                window.location = 'runningqueue.php';
            } else {
                alert('Failed...');
            }
        });
    });

    //export posts to csv file same as bboostr
    $('#export_csv').on("click", function() {
        let queuename = $('input[name=queuename]').val();
        let qinterval = $('input[name=qinterval]').val();
        let blogname  = $('select[name=blog]').val();
        let date      = $('input[name=since]').val();
        let limit     = $('input[name=limit]').val();

        if (!queuename || !qinterval || !blogname || !date || !limit) {
            alert("You have to input the * fields");
            return false;
        }

        date = date.split("/");
        date[2] = date[2].split(" ")[0];
        let f = new Date(date[2], date[0] - 1, date[1]);
        let seconds = f.getTime() / 1000;

        let formData = {
          'queuename': queuename,
          'qinterval': qinterval,
          'blogname': blogname,
          'since': seconds,
          'limit' : limit
        }

        if ($('input[name=input_blog]').val() !== "") {
            formData['fromBlogs'] = $('input[name=input_blog]').val();
        }

        if ($('input[name=tag]').val() !== "") {
            formData['tag'] = $('input[name=tag]').val();
        }

        if ($('select[name=type]').val() !== "") {
            formData['type'] = $('input[name=type]').val();
        }

        if ($('input[name=notecount]').val() === "") {
            formData['notecount'] = 1;
        } else { 
            formData['notecount'] = $('input[name=notecount]').val(); 
        }

        if ($('input[name=repeat]').val() === "") {
            formData['repeat'] = 1;
        } else { 
            formData['repeat'] = $('input[name=repeat]').val(); 
        }

        if ($('input[name=until]').val() !== "") {
            let dateuntil = $('input[name=until]').val().split("/");
            dateuntil[2] = dateuntil[2].split(" ")[0];
            let ff = new Date(dateuntil[2], dateuntil[0] - 1, dateuntil[1]);
            let secondsuntil = ff.getTime() / 1000;
            formData['until'] = secondsuntil;
        }
        if (confirm('Are you sure you want to export this?')) {
            $.ajax({
                type: 'POST',
                url: '../scripts/exportqueue.php',
                data: formData,
                dataType: 'json', 
                encode: true,
                complete: function() {
                    alert("Successfully Exported!");
                }
            })
            .done(function(response) {
                let csvContent = "data:text/csv;charset=utf-8,";
                    response.forEach(function(rowArray){
                        csvContent += rowArray + "\n";
                    }); 
                    let encodedUri = encodeURI(csvContent);
                    let link = document.createElement("a");
                    link.setAttribute("href", encodedUri);
                    link.setAttribute("download", "ruinedchildhood-posts-queue.csv");
                    document.body.appendChild(link);
                    link.click();
            });
        }
    });

    $('#remove_all').on('click', function(e) {
        if (confirm('Are you sure you want to remove all queues?')) {
            $.ajax({
                type: 'post',
                url: '../scripts/manageposts.php',
                data: {
                    remove_all: true
                },
                success: function(response) {
                    alert(response);
                    window.location.reload(true);
                }
            });
        }
    });

    $('#save_queue').on('click', function(e) {
        let queuename = $('input[name=queuename]').val();
        let qinterval = $('input[name=qinterval]').val();
        let blogname  = $('select[name=blog]').val();
        let date      = $('input[name=since]').val();
        let limit     = $('input[name=limit]').val();

        if (!queuename || !qinterval || !blogname || !date || !limit) {
            alert("You have to input the * fields");
            return false;
        }

        date = date.split("/");
        date[2] = date[2].split(" ")[0];
        let f = new Date(date[2], date[0] - 1, date[1]);
        let seconds = f.getTime() / 1000;

        let formData = {
          'queuename': queuename,
          'qinterval': qinterval,
          'blogname': blogname,
          'since': seconds,
          'limit' : limit
        }

        if ($('input[name=input_blog]').val() !== "") {
            formData['fromBlogs'] = $('input[name=input_blog]').val();
        }

        if ($('input[name=tag]').val() !== "") {
            formData['tag'] = $('input[name=tag]').val();
        }

        if ($('select[name=type]').val() !== "") {
            formData['type'] = $('input[name=type]').val();
        }

        if ($('input[name=notecount]').val() === "") {
            formData['notecount'] = 1;
        } else { 
            formData['notecount'] = $('input[name=notecount]').val(); 
        }

        if ($('input[name=repeat]').val() === "") {
            formData['repeat'] = 1;
        } else { 
            formData['repeat'] = $('input[name=repeat]').val(); 
        }

        if ($('input[name=until]').val() !== "") {
            let dateuntil = $('input[name=until]').val().split("/");
            dateuntil[2] = dateuntil[2].split(" ")[0];
            let ff = new Date(dateuntil[2], dateuntil[0] - 1, dateuntil[1]);
            let secondsuntil = ff.getTime() / 1000;
            formData['until'] = secondsuntil;
        }
        // process the form
        $.ajax({
            type: 'POST', // define the type of HTTP verb we want to use (POST for our form)
            url: '../scripts/managequeues.php', // the url where we want to POST
            data: formData, // our data object
            dataType: 'json', // what type of data do we expect back from the server
            encode: true,
            success: function(data) {
                $('#save_queue').prop('disabled', false);
                if (data.success === true) {
                    alert(data.message);
                } else {
                    alert(data.errors);
                    return false;
                }
            }
        });
        // stop the form from submitting the normal way and refreshing the page
        e.preventDefault();
        $('#save_queue').prop('disabled', true);
    });

    Dropzone.options.csvImportDropzone = {
        paramName: "file",
        maxFilesize: 50,
        uploadMultiple: true,
        parallelUploads: 5,
        maxFiles: 1,
        url: '../scripts/csvimport.php',
        clickable: true,
        addRemoveLinks: true,
        acceptedFiles: '.csv',
        dictDefaultMessage: "Upload your files here",
        init: function() {
            let cd;
            this.on("success", function(file, response) {
                $('.dz-progress').hide();
                $('.dz-size').hide();
                $('.dz-error-mark').hide();
                cd = response;
            });
        },
        success: function(state, res) {
            let response = JSON.parse(res);
            if (response.success) {
                alert(response.message);
            } else {
                alert(response.errors);
            }

            window.location = 'runningqueue.php';
        }
    };

    $('#set_private_public').on('click', function(e) {
        if (confirm('Really perform this process?')) {
            let username = $('#set_private_public').attr('data');
            let state = $('#set_private_public').attr('state');

            $.ajax({
                type: 'post',
                url: '../scripts/manageposts.php',
                data: {
                    username,
                    state,
                    postStatusChange: true
                },

                success: function(response) {
                    if (response === 'success') {
                        alert('It has been set succesfully! Please wait as it may take a long time.');
                    } else {
                        alert('Failed... Please try again!');
                    }
                }
            });
        }
    });
});

function convertToCSV(objArray) {
    let array = typeof objArray != 'object' ? JSON.parse(objArray) : objArray;
    let str = '';

    for (let i = 0; i < array.length; i++) {
        let line = '';
        for (let index in array[i]) {
            if (line != '') line += ','

            line += array[i][index];
        }

        str += line + '\r\n';
    }

    return str;
}

function exportToCSV(header, items) {
    if (header) {
        items.unshift(header);
    }

    let jsonObject = JSON.stringify(items);
    let csv = this.convertToCSV(jsonObject);
    let exportedFilenmae = 'queue-exports' + '.csv';
    let blob = new Blob([csv], { type: 'text/csv;charset=utf-8;' });

    if (navigator.msSaveBlob) { // IE 10+
        navigator.msSaveBlob(blob, exportedFilenmae);
    } else {
        let link = document.createElement("a");
        if (link.download !== undefined) { // feature detection
            // Browsers that support HTML5 download attribute
            let url = URL.createObjectURL(blob);
            link.setAttribute("href", url);
            link.setAttribute("download", exportedFilenmae);
            link.style.visibility = 'hidden';
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }
    }
}

function addBlogInput() {
    if(blogcounter == bloglimit) {
        alert("You have reached the limit of adding " + blogcounter + " inputs");
    } else {
        let newinput = document.createElement('input');
        newinput.type = 'text';
        newinput.name = 'input_blog' + (blogcounter);
        newinput.className = 'form-control col-md-7 col-xs-12 input_blog';
        newinput.id = 'input_blog' + (blogcounter);
        newinput.placeholder = 'Blog name';
        document.getElementById("bloglist").appendChild(newinput);
        ++blogcounter;
    }
    
}