<?php
set_time_limit(0);

$base_dir = "test_script";
require_once('/home/tagblrco/public_html/Rc01/inc/tumblroauth.php');
require_once('/home/tagblrco/public_html/Rc01/inc/config.php');

$tracker_id = 0;
if ($argc >= 2) {
    $tracker_id = $argv[1];
}else{
    echo "no arg";
    exit();
}
echo "-------TRACKER ID: " . $tracker_id . "-------------\n";
$mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);

if (mysqli_connect_errno()) {
    printf("Connect failed: %s\n", mysqli_connect_error());
    exit();
}

$access_time    = time();
if ($result = $mysqli->query("SELECT * FROM trackers WHERE id = '$tracker_id'")) {
    while($obj = $result->fetch_object()) {
        $auth_token = $obj->oauth_token;
        $auth_secret= $obj->oauth_token_secret;
        $source     = $obj->source;
        $dest       = $obj->destination;
        $interval   = intval($obj->post_interval);
        $tag        = $obj->tag;
        $type       = $obj->type;
        $notecount  = $obj->note_count;
        $last       = $obj->last_access;
        $username   = $obj->username;
        $addingTag  = $obj->adding_tag;
        $qname      = $source . "tracker" . $tracker_id;
        $qname      = str_replace(" ", "", $qname);
        $qname      = str_replace("-", "", $qname);

        $connection = new TumblrOAuth(CONSUMER_KEY, CONSUMER_SECRET, $auth_token, $auth_secret);

        if($type != "")
            $url = 'blog/'. $source .'.tumblr.com/posts/'. $type;
        else
            $url = 'blog/'. $source .'.tumblr.com/posts';

        $params = array('api_key' => CONSUMER_KEY);
        
        if($tag != '')
            $params["tag"] = $tag;

        $collection = $connection->get($url, $params);
        $filtered   = array();

        if (isset($collection['meta']) && ($collection['meta']['msg'] == 'OK')) {
            if ( sizeof($collection['response']['posts']) > 0) {
                foreach ( $collection['response']['posts'] as $single ) {
                    if ( ($single['timestamp'] < $last) ) {
                        echo $qname . " <=> break at timestamp " . $single['timestamp'] . "\n";
                        break;
                    }
    
                    if ( $single['note_count'] >= $notecount ) {
                        array_push($filtered, $single);
                    }
                }
            }
        }
        
        if (!empty($filtered)) {
            $status = "tracker";

            if (!$mysqli->query("SELECT 1 FROM $qname LIMIT 1")) {
                $mysqli->query("CREATE TABLE IF NOT EXISTS $qname (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,oauth_token VARCHAR(100),oauth_token_secret VARCHAR(100),post_interval INT, blogname VARCHAR(100),postid VARCHAR(50),reblog_key VARCHAR(50),type VARCHAR(10),notecount INT,state VARCHAR(15),title VARCHAR(100),body longtext,caption TEXT, external_url TEXT, embed longtext,quote TEXT,source TEXT,url TEXT, thumbnail TEXT, description TEXT, author TEXT, excerpt TEXT, conversation longtext,link TEXT ) ENGINE=InnoDB");
                if($notecount === NULL){
                    $stmt = $mysqli->prepare("INSERT INTO queues (queuename,username,toblog,fromblog,queued_tag,posts_since,queue_interval, adding_tag, status) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                    $stmt->bind_param('ssssssdss', $qname, $username, $dest, $source,$tag, $last, $interval, $addingTag, $status);
                } else {
                    $nt = intval($notecount);
                    $stmt = $mysqli->prepare("INSERT INTO queues (queuename,username,toblog,fromblog,queued_tag,notecount,posts_since,queue_interval,adding_tag,status) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                    $stmt->bind_param('sssssdsdss', $qname, $username, $dest, $source,$tag, $nt, $last, $interval, $addingTag, $status);
                }

                $stmt->execute();
                $stmt->close();
            }

            foreach ($filtered as $post) {
                switch ($post['type']) {
                    case 'text':
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, title, body) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['title'], $post['body']);
                        break;
            
                    case 'audio': 
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, caption, external_url) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['caption'], $post['audio_source_url']);
                        break;
                    
                    case 'video':
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, caption, embed) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['caption'], $post['player']['0']['embed_code']);
                        break;
                    
                    case 'quote':
                        
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, quote, source) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['text'], $post['source']);
                        break;
                    
                    case 'link':
                        
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, title, url, description, thumbnail, author, excerpt) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdssssss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['title'], $post['url'], $post['description'], $post['photos']['0']['original_size']['url'], $post['author'], $post['excerpt']);
                        break;
                    
                    case 'chat':
                        
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, title, conversation) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['title'], $post['body']);
                        break;
                    
                    case 'photo':
                        
                        $stmt      = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, caption, source, link) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
                        $stmt->bind_param('ssdssssdsss', $auth_token, $auth_secret, $interval, $dest, $post['id'], $post['reblog_key'], $post['type'], $post['note_count'], $post['caption'], $post['photos']['0']['original_size']['url'], $post['image_permalink']);
                        break;
                    
                    case 'answer':
                        break;
                    
                    default:
                        break;
                }
                if ($post['type'] != 'answer') {
                    echo "-------------success: " . $tracker_id . "-----------------------\n";
                    $stmt->execute();
                    $stmt->close();
                }
            }
            
            $fetched_time = time();
            if ($mysqli->query("UPDATE `trackers` SET last_access = '$fetched_time'  WHERE id = '$tracker_id'")) {
                echo "Time updated";
            } else {
                echo "time Not updated";
            }
        }
    }
} else{
    mysqli_close($mysqli);
    echo "No requestd Tracker";
    exit();
}

?>