<?php
set_time_limit(0);
require_once ('../inc/tumblroauth.php');
require_once ('../inc/config.php');
require_once ('../inc/process_class.php');

$username = "";
if ($argc >= 2) { //so $argc=2 means 1 argument
   $username = $argv[1];
}

if ($username === "") {
	exit;
}

$mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME);

if (mysqli_connect_errno()) {
    printf("Connect failed: %s\n", mysqli_connect_error());
    exit();
}

$i = 0;
$query_tmp = "SELECT * FROM dashboardstate WHERE username = '$username' ";
while ($r = mysqli_query($mysqli, $query_tmp )) {
    if( $ro = mysqli_fetch_assoc($r)) {
		if ($ro["state"] === "running") {
			if ($result = $mysqli->query("SELECT *  FROM dashboard WHERE exclude = 'N' AND username = '$username' ")) {
				echo "\ntotal ".$result->num_rows."rows in dashboard table\n";
				while($obj = $result->fetch_object()) {
					echo "++++++++++++++++++++++++++\n";
					var_dump($obj);
					echo "<br>" . $obj->username."\n";
					$qname         = $obj->username . "dashqueue";
					$qname 	       = str_replace("-", "", $qname);
					$fromblogs     = "dashboard";
					$tag           = "";
					$notecount     = 0;
					$since         = "";
					$max_count     = $obj->qlimit;
					$total_fetched = 0;
					$queue_status  = "dashboard";
	
					if (!$mysqli->query("SELECT 1 FROM $qname LIMIT 1")) {
						$mysqli->query("CREATE TABLE IF NOT EXISTS $qname (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, oauth_token VARCHAR(100), oauth_token_secret VARCHAR(100), 
							post_interval INT, blogname VARCHAR(100), postid VARCHAR(50), reblog_key VARCHAR(50), type VARCHAR(10), notecount INT, state VARCHAR(15), title VARCHAR(100),
							body longtext, caption TEXT, external_url TEXT, embed longtext, quote TEXT, source TEXT, url TEXT, thumbnail TEXT, description TEXT, author TEXT, excerpt TEXT, 
							conversation longtext, link TEXT ) ENGINE=InnoDB");
						
						$stmt = $mysqli->prepare("INSERT INTO queues (queuename, username, toblog, fromblog, queued_tag, notecount, posts_since, queue_interval, status) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
						$stmt->bind_param('sssssdsds', $qname, $obj->username, $obj->postto, $fromblogs, $tag, $notecount, $since, $obj->postinterval, $queue_status);
						$stmt->execute();
						$stmt->close();
						echo $qname."table created\n";
					  } else {
						$result = $mysqli->query("SELECT * FROM $qname");
						$total_fetched = $result->num_rows;
						$result->close();
						echo $total_fetched."fetched <".$max_count."max\n";
					}
	
					if($max_count > $total_fetched) {
						echo "still send request\n";
						$connection = new TumblrOAuth(CONSUMER_KEY, CONSUMER_SECRET,$obj->oauth_token,$obj->oauth_token_secret);
						$limit		= 20;
						$res 		= [];
						$collection = $connection->get('user/dashboard',array('limit' => $limit));
						//var_dump($collection);
						  if(isset($collection["meta"]) && ($collection["meta"]["msg"]=="OK")){
							if(isset($collection['response']['posts'])){
								foreach($collection['response']['posts'] as $single) {
									//	array_push($res, $single);
									if($total_fetched >= $max_count)
										continue;
									if ($obj->posttype !== "")
										if(strcmp($single['type'], $obj->posttype) !== 0 )
											continue;
									if($single['note_count'] < $obj->notecount)
										continue;
									echo $obj->username.$single['reblog_key'].$single['type']."\n";
									switch ($single['type']) {
										case 'text':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, title, body) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['title'],$single['body']);   
											break;
							
										case 'audio':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, notecount, caption, external_url) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['caption'],$single['audio_source_url']);   
											break;
							
										case 'video':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, caption, embed) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['caption'],$single['player']['0']['embed_code']);
											break;
							
										case 'quote':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, quote, source) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['text'],$single['source']);   
											break;
							
										case 'link':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, title, url, description, thumbnail, author, excerpt) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdssssss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['title'],$single['url'],$single['description'], $single['photos']['0']['original_size']['url'],$single['author'],$single['excerpt']);   
											break;
							
										case 'chat':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, title, conversation) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['title'],$single['body']);   
											break;
							
										case 'photo':
											$notecount = intval($single['note_count']);
											$stmt = $mysqli->prepare("INSERT INTO $qname (oauth_token, oauth_token_secret,post_interval, blogname, postid, reblog_key, type, notecount, caption, source, link) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
											$stmt->bind_param('ssdssssdsss',$obj->oauth_token, $obj->oauth_token_secret,$obj->postinterval,$obj->postto,$single['id'],$single['reblog_key'],$single['type'],$notecount,$single['caption'],$single['photos']['0']['original_size']['url'],$single['image_permalink']);   
											break;
							
										case 'answer':
											break;
							
										default:
											break;
									}
									if($single['type'] != 'answer'){
										$stmt->execute();
										$total_fetched++;
										$stmt->close();  
									}
								}
							} else {
								var_dump($collection["meta"]);
								break 2;
							}
						} else {
							var_dump( $collection["meta"]);
							//let know dashboard stopped
							$result = $mysqli->query("TRUNCATE TABLE dashboardstate");
							break 2;	
						}
						
						if($i == 0) {
							   $cmd='/opt/cpanel/ea-php56/root/usr/bin/php process.php '.$qname;
							$process = new Process($cmd);
							$process->start();
							echo "Posting Script Process- ".$process->getPid()." Started\n";
						   }
						   unset($connection);  
					}
				}
				$result->close();
			} else {
				break;
			}
			
			echo "fetched once\n"; 
			$mysqli->close();
			sleep(60);
			$mysqli = new mysqli(DB_HOST, DB_USER, DB_PASS, DB_NAME); 
			$i++;
		}
	} else {
		exit;
	}
}

?>