<?php
error_reporting(E_ALL);
ini_set('display_errors',1);
session_start();
require_once('../inc/tumblroauth.php');
require_once('../inc/config.php');
require_once('../inc/process_class.php');
require_once('../inc/ChromePhp.php');
require_once('../inc/DB.php');

/* If access tokens are not available redirect to connect page. */
if (empty($_SESSION['access_token']) || empty($_SESSION['access_token']['oauth_token']) || empty($_SESSION['access_token']['oauth_token_secret'])) {
  header('Location: ../inc/redirect.php');
}

$db     = DB::getInstance();
$mysqli = $db->getConnection();

if (mysqli_connect_errno()) {
  printf("Connect failed: %s\n", mysqli_connect_error());
  exit();
}

ChromePhp::log('Started');
ChromePhp::log('DB Connect');

$errors = "";
$data   = array();
$result = array();

$access_token   = $_SESSION['access_token'];

$post_notecount = intval($_POST['notecount']);
$post_interval  = intval($_POST['qinterval']);
$post_repeat    = intval($_POST['repeat']);
$queue_status   = "active";
$blogname       = $_POST['blogname'];

$queuename      = str_replace(" ", "", $_POST['queuename']);
$queuename      = str_replace("-", "", $queuename);

if ( isset($_SESSION['userblog']) && $_SESSION['userblog'] !== '')
  $username     = $_SESSION['userblog'];
else
  $username     = "";

if (isset($_POST['limit']))
  $limit     = intval($_POST['limit']);

if (isset($_POST['fromBlogs']) && $_POST['fromBlogs'] != "") {
  ChromePhp::log('With Bloged API');
  $post_fromblogs = $_POST['fromBlogs'];
  $size = 0;
  $requestlink="";

  while(true) {
    if ( isset($_POST['tag']) ) {
      $requestlink = 'http://api.tumblr.com/v2/blog/' . $post_fromblogs . '.tumblr.com/posts?tag=' . $_POST['tag'] . '&offset=' . $size . '&notes_info=true&reblog_info=true&api_key=' . CONSUMER_KEY;
    } else {
      $requestlink = 'http://api.tumblr.com/v2/blog/' . $post_fromblogs . '.tumblr.com/posts?offset=' . $size . '&notes_info=true&reblog_info=true&api_key=' . CONSUMER_KEY;
    }

    $ch = curl_init($requestlink);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $collection = json_decode(curl_exec($ch), true);
    curl_close($ch);

    if ( isset($collection['meta']) && ($collection['meta']['msg'] == 'OK') ) {
      if ( $collection['response']['total_posts'] == 0 || sizeof($collection['response']['posts']) < 20) {
        $errors = "Not existed";
        break;
      }

      $size += sizeof($collection['response']['posts']);

      foreach ( $collection['response']['posts'] as $single ) {
        if ( isset($_POST['type']) && ($single['type'] !== $_POST['type']) ) {
          continue;
        }

        if ( isset($_POST['until']) ) {
          if ($single['timestamp'] > $_POST['until']) {
            continue;
          }
        }

        if ( (sizeof($result) >= $limit) && ($limit > 0 )) {
          ChromePhp::log('breaked at limit'.sizeof($result)."--".$limit);
          break 2;
        }

        if ( ($single['timestamp'] < $_POST['since']) ) {
          ChromePhp::log($single['timestamp'].'breaked at since');
          break 2;
        }

        if ( $single['note_count'] >= $_POST['notecount'] ) {
          array_push($result, $single);
        }
      }
    } else {
      $errors = $collection['meta']['msg'];
    }        
  }
  ChromePhp::log('total'. $size . ' Posts Fetched');

} else {
  ChromePhp::log('With Tagged API');
  $post_fromblogs = "";
  $lasttime = 0;

  if (isset($_POST['tag'])) {
    $requestlink = 'http://api.tumblr.com/v2/tagged?tag=' . $_POST['tag'] . '&api_key=' . CONSUMER_KEY;
    $ch     = curl_init($requestlink);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $collection = json_decode(curl_exec($ch), true);
    curl_close($ch);

    if (isset($collection['meta']) && ($collection['meta']['msg'] == 'OK')) {
      foreach ($collection['response'] as $single) {
        if (isset($_POST['type']) && ($single['type'] !== $_POST['type'])) {               
          continue;
        }
        if (isset($_POST['until'])) {
          if ($single['timestamp'] > $_POST['until']) 
            continue;
        }
        if ((sizeof($result) >= $limit) && ($limit > 0)) {
          ChromePhp::log('breaked at limit'.sizeof($result)."--".$limit);
          break;
        }   
        if (($single['timestamp'] < $_POST['since'])) {
          ChromePhp::log($single['timestamp'].'breaked at since');
          break;
        } 
        if ($single['note_count'] >= $_POST['notecount']) {
          array_push($result, $single);
        }
      }
      
      $lasttime = $collection['response'][sizeof($collection['response']) - 1]['timestamp'];
    } else {
      $errors = $collection['meta']['msg'];
    }

    if ($lasttime != 0) {
      ChromePhp::log('Before Tagged While');
      while (true) {
        if (sizeof($collection['response']) < 20){
          $errors = "Not existed";
          break;
        }
        // ChromePhp::log('In tagged While');
        $stragain = 'http://api.tumblr.com/v2/tagged?tag=' . $_POST['tag'] . '&before=' . $lasttime . '&api_key=' . CONSUMER_KEY;
        $ch       = curl_init($stragain);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POST, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $collection = json_decode(curl_exec($ch), true);
        curl_close($ch);
  
        if (isset($collection['meta']) && ($collection['meta']['msg'] == 'OK')) {
          if (sizeof($collection['response']) == 0) {
            break;
          }
          
          $lasttime = $collection['response'][sizeof($collection['response']) - 1]['timestamp'];
          foreach ($collection['response'] as $single) {
            if (isset($_POST['type']) && ($single['type'] !== $_POST['type'])) {                  
              continue;
            }
            if (isset($_POST['until'])){
              if ($single['timestamp'] > $_POST['until']) {
                continue;               
              }
            }
            if ((sizeof($result) >= $limit) && ($limit > 0)){
              ChromePhp::log('breaked at limit'.sizeof($result)."--".$limit);
              break 2;
            }  
            if (($single['timestamp'] < $_POST['since'])) {
              ChromePhp::log($single['timestamp'].'breaked at since');
              break 2;
            }
            if ($single['note_count'] >= $_POST['notecount']) {
              array_push($result, $single);
            }
          }
          if (sizeof($collection['response']) < 20) {
            $errors = "Not existed";
            break;
          }
        } else {
          $errors = $collection['meta']['msg'];
        }
      }
    } else {
      $errors = "Not existed";
    }
  } else {
    $errors = "Failed. Note: you should input either blog name or tag name.";
  }
}

$exportdata = array();
if (!empty($result)) {
  shuffle($result);
  for ($i = 1; $i <= $post_repeat; $i++) {
    foreach ($result as $post) {
      $fromBlogName = isset($_POST['fromBlogs']) ? $_POST['fromBlogs'] : "tagged posts";
      $line = $fromBlogName.";".$post['id'].";".$post['reblog_key'].";;";
      array_push($exportdata, $line);
    }
  }
  $size = sizeof($exportdata);
  ChromePhp::log('Result size ' . $size);
}

if (!empty($errors)) {
  $data['success'] = false;
  $data['errors']  = $errors;
} else {
  $data['success'] = true;
  $data['message'] = 'Success!';
  $data['data']    = $exportdata;
}
echo json_encode($exportdata);
?>