<?php
require_once('../inc/DB.php');
require_once('../inc/tumblroauth.php');
require_once('../inc/process_class.php');
require_once('../inc/config.php');

$db     = DB::getInstance();
$mysqli = $db->getConnection();

if (mysqli_connect_errno()) {
    printf("Connect failed: %s\n", mysqli_connect_error());
    exit();
}

if( isset( $_POST['display'] ) && $_POST['display'] === "true") {
    $return = '<table id="datatable" class="table table-striped table-bordered bulk_action">
        <thead>
            <tr>
                <th>ID</th>
                <th>Queue Name</th>
                <th>Blog Name</th>
                <th>Body</th>
                <th>Type</th>
                <th>Notecount</th>
                <th>Action</th>
            </tr>
        </thead>
        <tbody>';

    $queuename = $_POST['queuename'];

    if ($result = $mysqli->query("SELECT *  FROM $queuename")) {
        while($obj = $result->fetch_object()) {
            if (isset($obj->type)) {
                switch ($obj->type) {
                    case 'text':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td>' . $obj->body . '</td><td>' . $obj->type . '</td><td>' . $obj->notecount . 
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>';
                        break;
    
                    case 'audio':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td>' . $obj->external_url . '</td><td>' . $obj->type . '</td><td>' . $obj->notecount .
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>'; 
                            break;
    
                    case 'video':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td>' . $obj->embed . '</td><td>' . $obj->type . '</td><td>' . $obj->notecount .
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>'; 
                        break;
    
                    case 'quote':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td>' . $obj->quote . '</td><td>' . $obj->type . '</td><td>' . $obj->notecount .
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>'; 
                        break;
    
                    case 'link':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td>' . $obj->title . '</td><td>' . $obj->type . '</td><td>' . $obj->notecount .
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>'; 
                        break;
    
                    case 'chat':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td>' . $obj->conversation . '</td><td>' . $obj->type . '</td><td>' . $obj->notecount .
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>'; 
                        break;
    
                    case 'photo':
                        $return .= '<tr><td>' . $obj->id . '</td><td>' . $queuename . '</td><td>' . $obj->blogname . '</td><td><img width="100%" src="'.$obj->source.'"></td><td>' . $obj->type . '</td><td>' . $obj->notecount .
                            '</td><td><span class="glyphicon glyphicon-remove" id="p_delete"></span></td></tr>';
                        break;
    
                    default:
                        break;
                }
            }
        }
    }

    $return .= '</tbody>';
    echo $return;
    unset($obj);
}

if (isset($_POST['update']) && $_POST['update'] === "true") {
    $queuename = $_POST['queuename'];
    $interval  = $_POST['interval'];
    $res       = "";

    if ($result = $mysqli->query("UPDATE `queues` SET queue_interval = '" . $interval .  "' WHERE queuename = '" . $queuename . "' ")) {
        $res = "Post updated successfully";
    } else {
        $res = "Not updated";
    }

    echo $res;
}

if (isset($_POST['delete']) && $_POST['delete'] === "true") {
    $queuename = $_POST['queuename'];
    $res       = "";
    if ($result = $mysqli->query("DELETE FROM `queues` WHERE queuename = '" . $queuename . "' ")) { 
        $mysqli->query("DROP TABLE IF EXISTS $queuename");
        $res = "Queue deleted successfully";
    } else {
        $res = "Not deleted";
    }

    echo $res;
}

if (isset($_POST['post_delete']) && $_POST['post_delete'] === "true") {
    $queuename = $_POST['queuename'];
    $id        = $_POST['id'];
    $blogname  = $_POST['blogname'];
    $res       = "";

    if ($row = $mysqli->query("SELECT * FROM $queuename WHERE id = '" . $id . "' ")) {
        if ($obj = mysqli_fetch_assoc($row)) {
            $postId             = $obj['postid'];
            $oauth_token        = $obj["oauth_token"];
            $oauth_token_secret = $obj["oauth_token_secret"];
            $connection         = new TumblrOAuth(CONSUMER_KEY, CONSUMER_SECRET, $oauth_token, $oauth_token_secret);
            $status             = $connection->post('blog/' . $blogname . '.tumblr.com/post/delete', array('id' => $id));

            $result = $mysqli->query("DELETE FROM $queuename WHERE id = '" . $id . "' ");
            
            $res = "Post deleted successfully";
        }
    } else {
        $res = "Failed";
    }

    echo $res;
}

if (isset($_POST['own_post_del']) && $_POST['own_post_del'] === "true") {
    $id        = $_POST['id'];
    $blogname  = $_POST['blogname'];
    $postId    = $_POST['postId'];
    $db_name   = $_POST['username'] . "_posts";

    if ($row = $mysqli->query("SELECT * FROM $db_name WHERE id = '" . $id . "' ")) {
        if ($obj = mysqli_fetch_assoc($row)) {
            $postId             = $obj['postid'];
            $oauth_token        = $obj["oauth_token"];
            $oauth_token_secret = $obj["oauth_token_secret"];
            $connection         = new TumblrOAuth(CONSUMER_KEY, CONSUMER_SECRET, $oauth_token, $oauth_token_secret);
            $status             = $connection->post('blog/' . $blogname . '.tumblr.com/post/delete', array('id' => $postId));
            
            if ($status['meta']['msg'] === "OK") {
                $result = $mysqli->query("DELETE FROM $db_name WHERE id = '" . $id . "' ");
                $res = "Post deleted successfully";
            }
        }
    } else {
        $res = "Failed";
    }

    echo $res;
}

if (isset($_POST['remove_all']) && $_POST['remove_all'] === "true") {
    if ( isset($_SESSION['userblog']) && $_SESSION['userblog'] !== '') {
        $username     = $_SESSION['userblog'];
        if ($row = $mysqli->query("SELECT * FROM queues WHERE username='$username'")) {
            while($obj = $row->fetch_object()) {
                $queuename = $obj->queuename;
                $mysqli->query("DROP TABLE IF EXISTS $queuename");
                $mysqli->query("DELETE FROM queues WHERE queuename = '" . $queuename . "' ");
            }
            echo "Queues Deleted Successfully";
        }
    } else {
        echo "Failed...";
    }
}

if (isset($_POST['username']) && isset($_POST['state']) && $_POST['postStatusChange'] === "true") {
    $username = $_POST['username'];
    $state    = $_POST['state'];
    if ($state === "published")
        $state = "private";
    else
        $state = "published";

    if ($mysqli->query("UPDATE `user_info` SET postState = '$state' WHERE username='".$username."'")) {
        $cmd     = '/opt/cpanel/ea-php56/root/usr/bin/php postStatusProcess.php ' . $username . ' ' . $state;

        $process = new Process($cmd);
        $process->start();
        if ($process->status()) {
            echo "success";
        } else {
            echo "error";
        }
    } else {
        echo "error";
    }
}

mysqli_close($mysqli);
exit;

?>