<?php
    session_start();
    require_once('../inc/tumblroauth.php');
    require_once('../inc/config.php');
    require_once('../inc/DB.php');

    if (!isset($_SESSION) || !isset($_SESSION["userId"]) || !isset($_SESSION["username"])) {
        header("Location: ../index.php");
    }

    $db         = DB::getInstance();
    $mysqli     = $db->getConnection();
    $avatar     = '../images/user.png';
    $blogs      = array();
    $userblog   = '';
    $followings = 0;
    $followers  = 0;
    $likes      = 0;

    if ($res = $mysqli->query("SELECT *  FROM user_info WHERE id='".$_SESSION["userId"]."'")) {
        while($obj = $res->fetch_object()) {
            $avatar     = $obj->userblog ? 'https://api.tumblr.com/v2/blog/'. $obj->userblog .'.tumblr.com/avatar/128' : '../images/user.png';
            $blognames  = $obj->blognames;
            $blogs      = explode(",", $blognames);
            array_pop($blogs);
            $userblog   = $obj->userblog;
            $followings = $obj->followings;
            $followers  = $obj->followers;
            $likes      = $obj->likes;
            $oauth_token        = $obj->oauth_token;
            $oauth_token_secret = $obj->oauth_token_secret;
            $postState  = $obj->postState;

            $access_token = array(
                'oauth_token'        => $oauth_token,
                'oauth_token_secret' => $oauth_token_secret
            );
            $_SESSION['access_token'] = $access_token;
            $_SESSION['userblog']     = $userblog;
        }
    }
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <!-- Meta, title, CSS, favicons, etc. -->
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>dashbort | </title>

    <!-- Bootstrap -->
    <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
    <!-- Font Awesome -->
    <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
    <!-- Animate.css -->
    <link href="../vendors/animate.css/animate.min.css" rel="stylesheet">
    <!-- bootstrap-daterangepicker -->
    <!-- iCheck -->
    <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
    <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
    <link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.min.css" rel="stylesheet">
    <!-- Datatables -->
    <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">
    <!-- Dropzone.js -->
    <link href="../vendors/dropzone/dist/min/dropzone.min.css" rel="stylesheet">
    <!-- Custom Theme Style -->
    <link href="../build/css/custom.css" rel="stylesheet">
    <link href="../css/form.css" rel="stylesheet">
</head>
<body class="nav-md">
    <div class="container body">
        <div class="main_container">
            <div class="col-md-3 left_col">
                <div class="left_col scroll-view">
                    <div class="navbar nav_title" style="border: 0;">
                        <a href="home.php" class="site_title"><i class="fa fa-paw"></i> <span>Tumblr  </span></a>
                    </div>

                    <div class="clearfix"></div>

                    <!-- menu profile quick info -->
                    <div class="profile clearfix">
                        <div class="profile_pic">
                            <img src="<?php echo $avatar; ?>" alt="..." class="img-circle profile_img">
                        </div>
                        <div class="profile_info">
                            <span>Welcome,</span>
                            <h2 id="owner"><?php echo $_SESSION['username']; ?></h2>
                        </div>
                    </div>
                    <!-- /menu profile quick info -->
                    <br />

                    <!-- sidebar menu -->
                    <div id="sidebar-menu" class="main_menu_side hidden-print main_menu">
                        <div class="menu_section">
                            <h3>General</h3>
                            <ul class="nav side-menu">
                                <li><a><i class="fa fa-home"></i> Home <span class="fa fa-chevron-down"></span></a>
                                    <ul class="nav child_menu">
                                        <li><a href="home.php">Dashborad</a></li>
                                        <li><a href="runningqueue.php">Running Queues</a></li>
                                        <li><a href="activetracker.php">Active Trackers</a></li>
                                    </ul>
                                </li>
                                <li><a><i class="fa fa-edit"></i> Scripts <span class="fa fa-chevron-down"></span></a>
                                    <ul class="nav child_menu">
                                        <li><a href="multipleposts.php">Mutiple Posts</a></li>
                                        <li><a href="singlepost.php">Single Post</a></li>
                                        <li><a href="trackblogs.php">Track Blogs</a></li>
                                        <li><a href="deleteposts.php">Delete Posts</a></li>
                                        <li><a href="csv.php">CSV Import</a></li>
                                    </ul>
                                </li>
                                <li><a><i class="fa fa-group"></i> Browse Blogs <span class="fa fa-chevron-down"></span></a>
                                    <ul class="nav child_menu">
                                    <?php
                                        foreach ($blogs as $blog) {
                                            echo "<li><a href='viewposts.php?param=". $blog ."'>".$blog."</a></li>";
                                        }
                                    ?>
                                    </ul>
                                </li>
                                <li><a href="../inc/setting.php?f=clear_session"><i class="fa fa-clone"></i>Clear Sessions</span></a></li>
                            </ul>
                        </div>
                    </div>
                    <!-- /sidebar menu -->

                    <!-- /menu footer buttons -->
                    <div class="sidebar-footer hidden-small">
                        <a data-toggle="tooltip" data-placement="top" title="Settings">
                            <span class="glyphicon glyphicon-cog" aria-hidden="true"></span>
                        </a>
                        <a data-toggle="tooltip" data-placement="top" title="FullScreen">
                            <span class="glyphicon glyphicon-fullscreen" aria-hidden="true"></span>
                        </a>
                        <a data-toggle="tooltip" data-placement="top" title="Lock">
                            <span class="glyphicon glyphicon-eye-close" aria-hidden="true"></span>
                        </a>
                        <a data-toggle="tooltip" data-placement="top" title="Logout" href="../inc/setting.php?f=logout">
                            <span class="glyphicon glyphicon-off" aria-hidden="true"></span>
                        </a>
                    </div>
                <!-- /menu footer buttons -->
                </div>
            </div>

            <!-- top navigation -->
            <div class="top_nav">
                <div class="nav_menu">
                    <nav>
                        <div class="nav toggle">
                            <a id="menu_toggle"><i class="fa fa-bars"></i></a>
                        </div>

                        <ul class="nav navbar-nav navbar-right">
                            <li class="">
                                <a href="javascript:;" class="user-profile dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                    <img src="<?php echo $avatar; ?>" alt=""><?php echo $_SESSION["username"]; ?>
                                    <span class=" fa fa-angle-down"></span>
                                </a>
                                <ul class="dropdown-menu dropdown-usermenu pull-right">
                                    <li><a href="../views/profile.php"><span>Profile</span></a></li>
                                    <?php 
                                        if ($userblog === '') {
                                            echo "<li><a href='../inc/redirect.php'><span>Connect To Tumblr</span></a></li>";
                                        }
                                    ?>
                                    <li><a href="../inc/setting.php?f=logout"><i class="fa fa-sign-out pull-right"></i> Log Out</a></li>
                                </ul>
                            </li>
                        </ul>
                    </nav>
                </div>
            </div>
            <!-- /top navigation -->